{$R+,S+,Q+}

 Uses SysUtils;

 Procedure Assert(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'error!!!');
    Writeln(F,S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Wrong Answer');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean);
  Begin
   WA(B,'');
  end;

 Procedure WA;
  Begin
   WA(True);
  end;

 Procedure Ok(B:Boolean;S:String);
  Var F:Text;
   Begin
    if (Not B) then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Ok');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure Ok(B:Boolean);
  Begin
    Ok(B,'');
  end;

 Procedure Ok;
  Begin
   Ok(True);
  end;

 Procedure PE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Presentation Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure PE(B:Boolean);
  Begin
   PE(B,'');
  end;

 Procedure PE;
  Begin
   PE(True);
  end;

 Procedure IE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Internal Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure IE(B:Boolean);
  Begin
   IE(B,'');
  end;

 Procedure IE;
  Begin
   IE(True);
  end;

 Const MinN = 2;
       MaxN = 100;

 Var  AnsX, AnsY, AnsZ, OutX, OutY, OutZ:LongInt;
      A:Array[1..MaxN, 1..MaxN] of Boolean;
      S:Array[1..MaxN] of LongInt;
      N:LongInt;

  Procedure InputData;
   Var F:Text;
       i, X, Y, Z:LongInt;
       C:Char;
    Begin
     {$I-}
     Assign(F, ParamStr(1));
     Reset(F);
     IE(IOResult <> 0, 'File Not Found');
     Read(F, N);
     IE(IOResult <> 0);
     IE(Not Eoln(F));
     IE(N < MinN);
     IE(N > MaxN);
     For i:=1 to N do
      Begin
       Read(F, S[i]);
       IE(IOResult <> 0);
       if i <> N then IE(SeekEoln(F));
      end;
     IE(Not Eoln(F));
     For i:=1 to N * (N - 1) - 1 do
      Begin
       Read(F, X);
       IE(IOResult <> 0);
       IE(SeekEOLN(F));
       IE(X < 1);
       IE(X > N);
       Read(F, Y);
       IE(IOResult <> 0);
       IE(SeekEoln(F));
       IE(Y < 1);
       IE(Y > N);
       IE(X = Y);
       Read(F, C);
       IE(IOResult <> 0);
       if C = '0' then
        Begin
         IE(Not Eoln(F));
         Z:=0;
        end else
       if C = '+' then
        Begin
         IE(SeekEOLN(F));
         Read(F, C);
         IE(IOResult <> 0);
         IE(Not Eoln(F));
         IE(C <> '1');
         Z:=1;
        end else
       if C = '-' then
        Begin
         IE(SeekEoln(F));
         Read(F, C);
         IE(IOResult <> 0);
         IE(Not Eoln(F));
         IE(C <> '1');
         Z:=-1;
        end else IE;
       IE(A[X, Y]);
       A[X, Y]:=True;
       if Z = 1 then Dec(S[X], 3) else
       if Z = -1 then Dec(S[Y], 3) else
        Begin
         Dec(S[X]);
         Dec(S[Y]);
        end;
       IE(Not EOLN(F));
      end;
     IE(Not SeekEof(F));
     Close(F);
    end;

  Procedure ProcessData;
   Var F:Text;
       i, X, Y:LongInt;
       Str:String;

    Function GetS(Var F:Text):String;
     Var S:String;
         C:Char;
      Begin
       {$I-}
       GetS:='';
       S:='';
       While (Not SeekEOLN(F))and(Not SeekEOF(F)) do
        Begin
         Read(F, C);
         if IOResult <> 0 then Exit;
         if (C <> ' ')and(C <> '#13')and(C <> '#10') then Break;
        end;
       S:=C;
       While (Not SeekEOLN(F))and(Not SeekEOF(F)) do
        Begin
         Read(F, C);
         if IOResult <> 0 then Exit;
         S:=S + C;
        end;
       GetS:=S;
      end;

    Begin
     For i:=1 to N do IE(S[i] < 0);
     X:=0;
     Y:=0;
     For i:=1 to N do
      if S[i] > 0 then
       if X = 0 then X:=i else
       if Y = 0 then Y:=i else IE;
     if Y = 0 then IE(S[X] <> 3) else IE((S[X] <> S[Y])or(S[X] <> 1));
     {$I-}
     Assign(F, ParamStr(3));
     Reset(F);
     IE(IOResult <> 0, 'Answer File Not Found');
     Read(F, AnsX);
     IE(IOResult <> 0);
     IE(SeekEoln(F));
     Read(F, AnsY);
     IE(IOResult <> 0);
     IE(SeekEoln(F));
     Str:=GetS(F);
     IE((Str <> '0')and(Str <> '-1')and(Str <> '+1'));
     if Str = '0' then AnsZ:=0 else
     if Str = '+1' then AnsZ:=1 else
     if Str = '-1' then AnsZ:=-1;
     Close(F);
     Assign(F, ParamStr(2));
     Reset(F);
     PE(IOResult <> 0);
     Read(F, OutX);
     PE(IOResult <> 0);
     PE(SeekEoln(F));
     PE(SeekEof(F));
     Read(F, OutY);
     PE(IOResult <> 0);
     PE(SeekEoln(F));
     PE(SeekEof(F));
     Str:=GetS(F);
     PE((Str <> '0')and(Str <> '-1')and(Str <> '+1'));
     PE(Not SeekEof(F));
     Close(F);
     if Str = '0' then OutZ:=0 else
     if Str = '+1' then OutZ:=1 else
     if Str = '-1' then OutZ:=-1;
     WA((AnsX <> OutX)or(AnsY <> OutY)or(AnsZ <> OutZ));
    end;

  Procedure OutputData;
   Begin
    Ok;
   end;

 Begin
  InputData;
  ProcessData;
  OutputData;
 end.
