{$R+,S+,Q+}

 Uses SysUtils;

 Procedure Assert(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'error!!!');
    Writeln(F,S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Wrong Answer');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean);
  Begin
   WA(B,'');
  end;

 Procedure WA;
  Begin
   WA(True);
  end;

 Procedure Ok(B:Boolean;S:String);
  Var F:Text;
   Begin
    if (Not B) then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Ok');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure Ok(B:Boolean);
  Begin
    Ok(B,'');
  end;

 Procedure Ok;
  Begin
   Ok(True);
  end;

 Procedure PE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Presentation Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure PE(B:Boolean);
  Begin
   PE(B,'');
  end;

 Procedure PE;
  Begin
   PE(True);
  end;

 Procedure IE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Internal Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure IE(B:Boolean);
  Begin
   IE(B,'');
  end;

 Procedure IE;
  Begin
   IE(True);
  end;

 Const MinN = 1;
       MaxN = 100;

 Var  N, Ans, Out:String;

  Function Check(S:String):Boolean;
   Var i:LongInt;
    Begin
     {$I-}
     Check:=False;
     if Length(S) < 1 then Exit;
     if S[1] = '-' then S:=Copy(S, 2, Length(S) - 1);
     if (S[1] < '1')or(S[1] > '9') then Exit;
     For i:=2 to Length(S) do
      if (S[i] < '0')or(S[i] > '9') then Exit;
     Check:=True;
    end;

  Function Cmp(S1, S2:String):LongInt;
   Begin
    {$I-}
    if Length(S1) < Length(S2) then Cmp:=-1 else
    if Length(S1) > Length(S2) then Cmp:=1 else
     Begin
      if S1 < S2 then Cmp:=-1 else
      if S1 > S2 then Cmp:=1 else Cmp:=0;
     end;
   end;

  Procedure InputData;
   Var F:Text;
    Begin
     {$I-}
     Assign(F, ParamStr(1));
     Reset(F);
     IE(IOResult <> 0, 'File Not Found');
     Read(F, N);
     IE(IOResult <> 0);
     IE(Not Eoln(F));
     IE(Length(N) < MinN);
     IE(Length(N) > MaxN);
     IE(Not SeekEOF(F));
     Close(F);
     IE(Not Check(N));
    end;

  Procedure ProcessData;
   Var F:Text;

    Begin
     {$I-}
     Assign(F, ParamStr(3));
     Reset(F);
     IE(IOResult <> 0, 'Answer File Not Found');
     Read(F, Ans);
     IE(IOResult <> 0);
     IE(Not Eoln(F));
     IE(Not SeekEOF(F));
     IE(Not Check(Ans));
     IE(Cmp(Ans, N) <> 1);
     Close(F);
     Assign(F, ParamStr(2));
     Reset(F);
     PE(IOResult <> 0);
     Read(F, Out);
     PE(IOResult <> 0);
     PE(Not SeekEof(F));
     PE(Not Check(Out));
     Close(F);
     WA(Ans <> Out);
    end;

  Procedure OutputData;
   Begin
    Ok;
   end;

 Begin
  InputData;
  ProcessData;
  OutputData;
 end.
