{$R+,S+,Q+}

 Uses SysUtils;

 Procedure Assert(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'error!!!');
    Writeln(F,S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Wrong Answer');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean);
  Begin
   WA(B,'');
  end;

 Procedure WA;
  Begin
   WA(True);
  end;

 Procedure Ok(B:Boolean;S:String);
  Var F:Text;
   Begin
    if (Not B) then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Ok');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure Ok(B:Boolean);
  Begin
    Ok(B,'');
  end;

 Procedure Ok;
  Begin
   Ok(True);
  end;

 Procedure PE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Presentation Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure PE(B:Boolean);
  Begin
   PE(B,'');
  end;

 Procedure PE;
  Begin
   PE(True);
  end;

 Procedure IE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Internal Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure IE(B:Boolean);
  Begin
   IE(B,'');
  end;

 Procedure IE;
  Begin
   IE(True);
  end;

 Const MinN = 1;
       MaxN = 5000;
       MinM = 1;
       MaxM = 1000000000;

 Type Point = Record
               X, Y:LongInt;
              end;

 Var A:Array[1..MaxN] of Point;
     N, M, K:LongInt;
     Ans, Out:Int64; 


  Procedure InputData;
   Var F:Text;
       i:LongInt;
    Begin
     {$I-}
     Assign(F, ParamStr(1));
     Reset(F);
     IE(IOResult <> 0, 'File Not Found');
     Read(F, N);
     IE(N < MinN);
     IE(N > MaxN);
     IE(IOResult <> 0);
     IE(SeekEoln(F));
     Read(F, M);
     IE(IOResult <> 0);
     IE(SeekEoln(F));
     Read(F, K);
     IE(IOResult <> 0);
     IE(Not Eoln(F));
     For i:=1 to N do
      Begin
       Read(F, A[i].X);
       IE(IOResult <> 0);
       IE(SeekEoln(F));
       Read(F, A[i].Y);
       IE(IOResult <> 0);
       IE(Not Eoln(F));
      end;
     IE(Not SeekEOF(F));
     Close(F);
    end;

  Procedure ProcessData;
   Var F:Text;
       i:LongInt;

    Procedure Swap(Var A, B:Point);
     Var Tmp:Point;
      Begin
       Tmp:=A;
       A:=B;
       B:=Tmp;
      end;

    Function Cmp(Var A, B:Point):LongInt;
     Begin
      if A.X < B.X then Cmp:=-1 else
      if A.X > B.X then Cmp:=1 else
      if A.Y < B.Y then Cmp:=-1 else
      if A.Y > B.Y then Cmp:=1 else Cmp:=0;
     end;

    Procedure Sort(L, R:LongInt);
     Var i, j:LongInt;
         B:Point;
      Begin
       i:=L;
       j:=R;
       B:=A[(L + R) Div 2];
       Repeat
        While Cmp(A[i], B) = -1 do Inc(i);
        While Cmp(A[j], B) = 1 do Dec(j);
        if i <= j then
         Begin
          Swap(A[i], A[j]);
          Inc(i);
          Dec(j);
         end;
       Until i > j;
       if L < j then Sort(L, j);
       if i < R then Sort(i, R);
      end;

    Begin
     Sort(1, N);
     For i:=2 to N do IE((A[i].X = A[i - 1].X)and(A[i].Y = A[i - 1].Y));
     For i:=1 to N do
      Begin
       IE(A[i].X < MinM);
       IE(A[i].X > M);
       IE(A[i].Y < MinM);
       IE(A[i].Y > M);
      end;
     IE(M < MinM);
     IE(M > MaxM);
     IE(K < MinM);
     IE(K > MaxM);
     {$I-}
     Assign(F, ParamStr(3));
     Reset(F);
     IE(IOResult <> 0, 'Answer File Not Found');
     Read(F, Ans);
     IE(IOResult <> 0);
     IE(Not Eoln(F));
     IE(Not SeekEOF(F));
     Close(F);
     Assign(F, ParamStr(2));
     Reset(F);
     PE(IOResult <> 0);
     Read(F, Out);
     PE(IOResult <> 0);
     PE(Not SeekEof(F));
     Close(F);
     WA(Ans <> Out);
    end;

  Procedure OutputData;
   Begin
    Ok;
   end;

 Begin
  InputData;
  ProcessData;
  OutputData;
 end.
